/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomHTMLDocument_H__
#define __GdomHTMLDocument_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDocument.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomHTMLDocument GdomHTMLDocument;
typedef struct _GdomHTMLDocumentClass GdomHTMLDocumentClass;


#define GDOM_TYPE_HTML_DOCUMENT            (gdom_html_document_get_type())
#define GDOM_HTML_DOCUMENT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_HTML_DOCUMENT, GdomHTMLDocument))
#define GDOM_HTML_DOCUMENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_HTML_DOCUMENT, GdomHTMLDocument)Class)
#define GDOM_IS_HTML_DOCUMENT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_HTML_DOCUMENT))
#define GDOM_IS_HTML_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_HTML_DOCUMENT))
#define GDOM_HTML_DOCUMENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_HTML_DOCUMENT, GdomHTMLDocumentClass))

typedef struct _GdomHTMLDocumentPrivate GdomHTMLDocumentPrivate;

struct _GdomHTMLDocument {
    GdomDocument parent_instance;
    GdomHTMLDocumentPrivate *priv;
};

struct _GdomHTMLDocumentClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_html_document_get_type (void);


/* XXX TODO: custom function gdom_html_document_open */

WEBKIT_API void
gdom_html_document_close (GdomHTMLDocument *thiz);


/* XXX TODO: custom function gdom_html_document_write */


/* XXX TODO: custom function gdom_html_document_writeln */

WEBKIT_API void
gdom_html_document_clear (GdomHTMLDocument *thiz);

WEBKIT_API void
gdom_html_document_capture_events (GdomHTMLDocument *thiz);

WEBKIT_API void
gdom_html_document_release_events (GdomHTMLDocument *thiz);

WEBKIT_API gboolean
gdom_html_document_has_focus (GdomHTMLDocument *thiz);

G_END_DECLS

#endif /* __GdomHTMLDocument_H__ */
